% Kpug is at Kp = 2. This part has been used to test for different steps

% tuning the controller
% The ultimate gain for the P controller is 2
s = tf('s');
Kug = 2;
Hut = 1/((s+1)^2*s);
Htop_tune = series(Kug,Hut);
Htuning = feedback(Htop_tune,1);
step(Htuning); % plot the result of a step on the transfer function
% Observe that the ultimate period is 6

%nichols PI tuning 
Kp = 0.45*Kug;
Ti = 6/1.2;

% build the PI transfer controller
Hc = parallel(Kp,1/(Ti*s)); % adding P and I term
Hu = 1/((s+1)^2*s);
Hbot = 1;
Htop = series(Hu,Hc);
hfeedb = feedback(Htop,Hbot,-1); % combine the transfer function with PI

pzmap(hfeedb); % plot of the poles (and zeros)

% get the step and impulse respone
step(hfeedb);
impulse(hfeedb);

